# decorator for executing indirect tail recursive functions written in the special form

def tail_recursive_executor(f):
    
    def do_as_iteration(*args):
        f = do_as_iteration.f
        while True:
            print('calling',f.__name__,'with arguments:',*args)
            base_case, val_or_f, *args = f(*args)
            if base_case:
                return val_or_f
            else:
                f = val_or_f.f
                
    do_as_iteration.f = f
    
    return do_as_iteration



@tail_recursive_executor
def factorial(n : int, acc : int = 1) -> int:
    if n == 0:
        return (True, acc)
    else:
        return (False, factorial, n-1, n*acc)
   
print(factorial(10),end='\n\n') 


@tail_recursive_executor
def list_sum (l : [int], acc : int = 0) -> int:
    if l == []:
        return (True, acc)
    else:
        return (False, list_sum, l[1:], acc+l[0])

print(list_sum([5, 3, 1, 4]),end='\n\n')


@tail_recursive_executor
def is_even(n):
    if n == 0:
        return (True, True)
    else:
        return (False, is_odd, n-1)
 
@tail_recursive_executor
def is_odd(n):
    if n == 0:
        return (True, False)
    else:
        return (False, is_even, n-1)
     
print(is_odd(5),end='\n\n')
